<template>
  <div class="ob-order">
    <template v-if="!noContract">
      <Preloader v-if="isLoading" />
      <div class="ob-order__header">
        <div class="ob-order__header-content">
          <div class="order-info">
            <obTooltip
              content="Заказ создан вручную пользователем"
              position="top-start"
            >
              <i class="icon hand"></i>
            </obTooltip>
            Заказ {{ orderNumber }}
            <span>Черновик</span>
          </div>
          <div class="order-details">
            <div class="order-type">
              Тип заказа: Трекинговый
            </div>
          </div>
        </div>
      </div>

      <div class="ob-order__content">
        <div class="ob-order__content-left">
          <div class="order-step">
            <div class="order-step__route">
              <div class="order-step__route-header">
                <h2 :class="{ active: isRouteValid }" class="order-step-title">
                  Маршрут
                  <i class="icon checked"></i>
                </h2>
                <div
                  class="order-step__route-info"
                  v-if="logchain && logchain.routeDuration > 0"
                >
                  <span>
                    {{ getLength(logchain.routeLength) + " км" || "0 км" }} ≈
                    {{ getDuration(logchain.routeDuration) || "0 дней" }} в
                    движении
                  </span>
                  <!-- <i class="icon map"></i>
                  Посмотреть на карте -->
                </div>
              </div>

              <div class="order-route">
                <div class="order-route__row" v-for="(loadingLocation, i) in loadingLocations" :key="`loading-${i}`">
                  <div class="order-route__location-input-path">
                    <i class="icon route-loading -diamond-orange-yellow" />
                    <b> Погрузка</b>
                    <i v-if="i > 0" class="icon close" @click="removeLoadingPoint(i)"></i>
                  </div>
                  <div class="order-route__row-content">
                    <div class="order-route__location">
                      <div class="order-route__location-input">
                        <ObAddressInput
                            display-exp="russian_address"
                            title="Откуда"
                            :address="loadingLocation.label"
                            :mapAddress="loadingLocation"
                            :prefixIcon="loadingLocation.icon || ''"
                            :is-address-only="true"
                            placeholder="Например, Мосфильмовская ул., 17, Москва, Россия, 119590"
                            :mapId="`map-loading-${i}`"
                            :data-qa="`loadingAddress-${i}`"
                            @input="setAddress(loadingLocation, $event)"
                            @on-change-address="setAddress(loadingLocation, $event)"
                        />
                      </div>
                      <div
                          class="order-route__points"
                          v-if="fromPointsShow || toPointsShow"
                      >
                        <ob-stepper
                            v-model="activeToPoints"
                            label="Точки посещения"
                            :min-value="1"
                            class="order-route__stepper"
                            :data-qa="`loadingPoints-${i}`"
                            @input="changePoints"
                            v-show="fromPointsShow"
                        />
                      </div>
                    </div>
                    <div class="order-route__date">
                      <order-date-picker
                        v-model="loadingLocation.loadingUnloadingDt"
                        :blockDaysBeforeToday="true"
                        label="Дата и время погрузки"
                        :isTime="true"
                        :timeInterval="15"
                        :allowWeekends="true"
                        :data-qa="`loadingDate-${i}`"
                        :isValidDate="loadingLocation.valid"
                        :is-validate-immediatly="true"
                        :dateValidationMessage="loadingLocation.errorTooltip"
                        @input="onDtChangeByUser(loadingLocation)"
                      >
                      </order-date-picker>
                    </div>
                  </div>
                  <div class="order-route__location-info" v-if="loadingLocation.locationTitle">
                    Относится к опорному пункту: <span>{{ loadingLocation.locationTitle }}</span>
                  </div>
                  <div class="order-route__row-radius" v-if="loadingLocation.label">
                    <div class="order-route__row-radius-item">
                      Радиус стоянки, м
                      <ob-input
                        type="number"
                        v-model.number="loadingLocation.parkingRadius"
                        :isValid="loadingLocation.parkingRadius >= 10 && !loadingLocation.isRadiusWrong && loadingLocation.parkingRadius <= 10000"
                        :validationMessage="loadingLocation.parkingRadius < 10 || loadingLocation.parkingRadius > 10000 ? 'Радиусы стоянки и погрузки должны быть в пределах от 10 до 10 000 метров' : loadingLocation.isRadiusWrong ? 'Радиус стоянки не может быть меньше радиуса разгрузки.' : ''"
                        :class="{wrong: loadingLocation.isRadiusWrong}"
                        @input="checkRadius(loadingLocation)"
                      />
                    </div>
                    <div class="order-route__row-radius-item">
                      Радиус погрузки, м
                      <ob-input
                        type="number"
                        :minValue="10"
                        :isValid="loadingLocation.targetRadius >= 10 && loadingLocation.targetRadius <= 10000"
                        :validationMessage="loadingLocation.targetRadius < 10 || loadingLocation.targetRadius > 10000 ? 'Радиусы стоянки и погрузки должны быть в пределах от 10 до 10 000 метров' : ''"
                        v-model.number="loadingLocation.targetRadius"
                        @input="checkRadius(loadingLocation)"
                      />
                    </div>
                    <ob-tooltip
                      content="Радиусы стоянки и погрузки должны быть в пределах от 10 до 10 000 метров"
                    >
                      <i class="icon question" />
                    </ob-tooltip>
                    <div class="order-route__radius-error" v-if="loadingLocation.isRadiusWrong">
                      Радиус стоянки не может быть меньше радиуса разгрузки.
                    </div>
                  </div>
                </div>
                <div class="order-route__add">
                  <i class="icon plus" />
                  <span @click="addLoadingPoint(null)"> Добавить погрузку</span>
                </div>

                <div class="order-route__row" v-for="(unloadingLocation, i) in unloadingLocations" :key="`unloading-${i}`">
                  <div class="order-route__location-input-path">
                    <i class="icon route-unloading -green-700" />
                    <b> Разгрузка</b>
                    <i v-if="i > 0" class="icon close" @click="removeUnloadingPoint(i)"></i>
                  </div>
                  <div class="order-route__row-content">
                    <div class="order-route__location">
                      <div class="order-route__location-input">
                        <ObAddressInput
                            display-exp="russian_address"
                            title="Куда"
                            :address="unloadingLocation.label"
                            :mapAddress="unloadingLocation"
                            :prefixIcon="unloadingLocation.icon || ''"
                            :is-address-only="true"
                            placeholder="Например, Мосфильмовская ул., 17, Москва, Россия, 119590"
                            :mapId="`map-unloading-${i}`"
                            :data-qa="`unloadingAddress-${i}`"
                            @input="setAddress(unloadingLocation, $event)"
                            @on-change-address="setAddress(unloadingLocation, $event)"
                        />
                      </div>
                      <div
                          class="order-route__points"
                          v-if="fromPointsShow || toPointsShow"
                      >
                        <ob-stepper
                            v-model="activeToPoints"
                            label="Точки посещения"
                            :min-value="1"
                            class="order-route__stepper"
                            :data-qa="`unloadingPoints-${i}`"
                            @input="changePoints"
                            v-show="fromPointsShow"
                        />
                      </div>
                    </div>
                    <div class="order-route__date">
                      <order-date-picker
                          v-model="unloadingLocation.loadingUnloadingDt"
                          :blockDaysBeforeToday="true"
                          label="Дата и время разгрузки"
                          :isTime="true"
                          :timeInterval="15"
                          :allowWeekends="true"
                          :data-qa="`unloadingDate-${i}`"
                          :isValidDate="unloadingLocation.valid"
                          :is-validate-immediatly="true"
                          :dateValidationMessage="unloadingLocation.errorTooltip"
                          @input="onDtChangeByUser(unloadingLocation)"
                      >
                      </order-date-picker>
                    </div>
                  </div>
                  <div class="order-route__location-info" v-if="unloadingLocation.locationTitle">
                    Относится к опорному пункту: <span>{{ unloadingLocation.locationTitle }}</span>
                  </div>
                  <div class="order-route__row-radius" v-if="unloadingLocation.label">
                    <div class="order-route__row-radius-item">
                      Радиус стоянки, м
                      <ob-input
                        type="number"
                        :minValue="10"
                        v-model.number="unloadingLocation.parkingRadius"
                        :isValid="unloadingLocation.parkingRadius >= 10 && !unloadingLocation.isRadiusWrong && unloadingLocation.parkingRadius <= 10000"
                        :validationMessage="unloadingLocation.parkingRadius < 10 || unloadingLocation.parkingRadius > 10000 ? 'Радиусы стоянки и погрузки должны быть в пределах от 10 до 10 000 метров' : unloadingLocation.isRadiusWrong ? 'Радиус стоянки не может быть меньше радиуса разгрузки.' : ''"
                        :class="{wrong: unloadingLocation.isRadiusWrong}"
                        @input="checkRadius(unloadingLocation)"
                      />
                    </div>
                    <div class="order-route__row-radius-item">
                      Радиус разгрузки, м
                      <ob-input
                        type="number"
                        :minValue="10"
                        :isValid="unloadingLocation.targetRadius >= 10 && unloadingLocation.targetRadius <= 10000"
                        :validationMessage="unloadingLocation.targetRadius < 10 || unloadingLocation.targetRadius > 10000 ? 'Радиусы стоянки и погрузки должны быть в пределах от 10 до 10 000 метров' : ''"
                        v-model.number="unloadingLocation.targetRadius"
                        @input="checkRadius(unloadingLocation)"
                      />
                    </div>
                    <ob-tooltip
                      content="Радиусы стоянки и погрузки должны быть в пределах от 10 до 10 000 метров"
                    >
                      <i class="icon question" />
                    </ob-tooltip>
                    <div class="order-route__radius-error" v-if="unloadingLocation.isRadiusWrong">
                      Радиус стоянки не может быть меньше радиуса разгрузки.
                    </div>
                  </div>
                </div>
                <div class="order-route__add">
                  <i class="icon plus" />
                  <span @click="addUnloadingPoint(null)"> Добавить разгрузку</span>
                </div>
              </div>
            </div>
          </div>

<!--          <div class="order-step">-->
<!--            <div class="order-step__services, .order-step__targets">-->
<!--              <h2 :class="{ active: isServicesValid }" class="order-step-title">-->
<!--                Услуги трекинга-->
<!--                <i class="icon checked"></i>-->
<!--              </h2>-->
<!--              <div class="order-services">-->
<!--                <service-card-->
<!--                  v-for="(service, index) in this.services"-->
<!--                  :key="index"-->
<!--                  :service="service"-->
<!--                  :active="isServiceActive(service.serviceUuid)"-->
<!--                  @serviceChanged="onServiceChanged"-->
<!--                />-->
<!--              </div>-->
<!--            </div>-->
<!--          </div>-->

          <div class="order-step">

            <div class="order-step__targets">
              <h2 class="order-step-title">
                Начало и окончание трекинга
              </h2>
              <div  class="order-targets__inputs">
                <div class="order-targets__short-date">
                  <order-date-picker
                      v-model="trackingStartDt.value"
                      :blockDaysBeforeToday="true"
                      label="Начало трекинга"
                      :isTime="true"
                      :timeInterval="15"
                      :allowWeekends="true"
                      data-qa="trackingStartDt"
                      :isValidDate="trackingStartDt.errorTooltip === ''"
                      :is-validate-immediatly="true"
                      :dateValidationMessage="trackingStartDt.errorTooltip"
                      @input="validateTrackingDt()"
                  >
                  </order-date-picker>
                </div>
                <div class="order-targets__short-date">
                  <order-date-picker
                      v-model="trackingEndDt.value"
                      :blockDaysBeforeToday="true"
                      label="Окончание трекинга"
                      :isTime="true"
                      :timeInterval="15"
                      :allowWeekends="true"
                      data-qa="trackingEndDt"
                      :isValidDate="trackingEndDt.errorTooltip === ''"
                      :is-validate-immediatly="true"
                      :dateValidationMessage="trackingEndDt.errorTooltip"
                      @input="validateTrackingDt()"
                  >
                  </order-date-picker>
                </div>
              </div>
            </div>
          </div>


          <ObForm
              :form-data="formData"
              :form-model="formModel"
              :is-show-controls="false"
              @validation="isValidForm = $event"
          >

            <div class="order-step">
              <div class="order-step__targets">
                <h2 :class="{ active: isTargetsValid }" class="order-step-title">
                  Отслеживаемые ТС
                  <i class="icon checked"></i>
                </h2>
                <div class="order-targets">
                  <div class="order-targets__header">
                    <ob-checkbox label="Госномер РФ" v-model="formatCarNumber" />
                  </div>
                  <div class="order-targets__inputs">
                    <ob-input
                        v-model.trim="formData.carNumber"
                        :mask="carNumberMask"
                        :mask-tokens="regnumMaskTokens"
                        label="Номер тягача"
                        required
                        isDirtyForce
                        class="order-targets__short-input"
                        property="carNumber"
                        @blur="dirtCarNumber"
                        @keydown.native="validateNumber($event, 'carNumber')"
                        @keyup.native="capitalizeNumber('carNumber')"
                    ></ob-input>
                    <ob-input
                        v-model="formData.trailerNumber"
                        :mask="trailerNumberMask"
                        :mask-tokens="regnumMaskTokens"
                        label="Номер прицепа"
                        class="order-targets__short-input"
                        property="trailerNumber"
                        isDirtyForce
                        @keydown.native="validateNumber($event, 'trailerNumber')"
                        @keyup.native="capitalizeNumber('trailerNumber')"
                    ></ob-input>
                  </div>
                </div>
                <div class="order-targets">
                  <div class="order-targets__header">
                    <ob-checkbox label="Телефон РФ" v-model="formatPhoneNumber" />
                  </div>
                  <div class="order-targets__inputs">
                    <ob-input
                        ref="driverPhone"
                        v-model="formData.driverPhone"
                        :mask="phomeNumberMask"
                        isMasked
                        label="Номер телефона водителя"
                        required
                        class="order-targets__short-input"
                        property="driverPhone"
                        @keydown.native="onPhoneEnter"
                        @paste.native="onPhonePaste"
                    ></ob-input>
                    <ob-input
                        v-model="formData.driverName"
                        placeholder="Укажите ФИО"
                        label="ФИО водителя"
                        required
                        class="order-targets__long-input"
                        property="driverName"
                    ></ob-input>
                  </div>
                </div>
              </div>
            </div>

          </ObForm>

          <div class="order-step">
            <div class="order-step__params">
              <h2 class="order-step-title">
                Параметры
              </h2>
              <div class="order-step__params-item">
                <ob-input v-model="externalNumber" placeholder="Укажите номер заказа" label="Внутренний № заказа по системе Заказчика"></ob-input>
              </div>
              <div class="order-step__params-item">
                <ob-text-area v-model="comment" label="Комментарий"></ob-text-area>
              </div>
            </div>
          </div>
        </div>
        <div class="ob-order__content-right">
          <div class="ob-order__content-right-container">
            <order-logist-info
              :client="client"
              :contractor="contractor"
              :logist="logist"
            />
<!--            <div class="ob-order__status" ref="cost">-->
<!--              <div class="prime-cost" v-if="!isCostBusy">-->
<!--                <h3>Стоимость</h3>-->
<!--                <p :class="['prime-cost__title', isCostExpanded ? 'prime-cost__title&#45;&#45;expanded' : '']" @click="isCostExpanded = !isCostExpanded">-->
<!--                  <span>-->
<!--                    <i class="icon chevron-down"></i>-->
<!--                    Услуги трекинга-->
<!--                  </span>-->
<!--                  <strong>{{ new Intl.NumberFormat("ru-RU").format(Math.round(cost.totalCost / 100)) }} ₽</strong>-->
<!--                </p>-->
<!--                <expand-transition-->

<!--                >-->
<!--                  <div v-if="isCostExpanded">-->
<!--                    <p v-for="service in cost.services" :key="service.serviceUuid">-->
<!--                      {{ service.title }}-->
<!--                      <span>-->
<!--                        {{ new Intl.NumberFormat("ru-RU").format(Math.round(service.price / 100)) }} ₽-->
<!--                      </span>-->
<!--                    </p>-->
<!--                    &lt;!&ndash; <p>Базовые услуги <span>53 000 ₽</span></p>-->
<!--                    <p>Контроль движения <span>3 000 ₽</span></p>-->
<!--                    <p>Уведомление участников <span>2 000 ₽</span></p> &ndash;&gt;-->
<!--                  </div>-->
<!--                </expand-transition>-->
<!--              </div>-->
<!--              <div v-else class="cost-preloader" ref="costPreloader">-->
<!--                <Preloader />-->
<!--              </div>-->
<!--            </div>-->

<!--            <div class="ob-order__status" v-if="!isCostBusy" ref="costFinal">-->
<!--              <div class="order-total">-->
<!--                <p>-->
<!--                  <span>Предварительно<br />к оплате</span>-->
<!--                  <span>{{ new Intl.NumberFormat("ru-RU").format(Math.round(cost.totalCost / 100)) }} ₽</span>-->
<!--                </p>-->
<!--                <p v-if="cost.totalVat && cost.totalVat > 0">-->
<!--                  <span>В том числе НДС</span>-->
<!--                  <span>{{ new Intl.NumberFormat("ru-RU").format(Math.round(cost.totalVat / 100)) }} ₽</span>-->
<!--                </p>-->
<!--                <p v-else>-->
<!--                  НДС не облагается-->
<!--                </p>-->
<!--              </div>-->
<!--            </div>-->

            <div class="ob-order__status">
<!--              <div class="oferta">-->
<!--                <ob-checkbox label="" v-model="oferta" />-->
<!--                <span>-->
<!--                  Принимаю условия-->
<!--                  <a href="#" @click.prevent="openOferta">-->
<!--                    Оферты-->
<!--                  </a>-->
<!--                  и выражаю согласие с ними-->
<!--                </span>-->
<!--              </div>-->
              <div class="ob-order__action">
                <ob-button
                  label="Оформить заказ"
                  :isFullWidth="true"
                  :disabled="!isOrderValid"
                  data-qa="btnOrderPlacement"
                  @click="changeOrderStatus"
                />
              </div>
              <div class="ob-order__action">
                <ob-button
                  label="Отменить заказ и выйти"
                  :isFullWidth="true"
                  type="flat"
                  data-qa="btnOrderCancel"
                  @click="cancelOrder"
                />
              </div>
            </div>
          </div>
        </div>
      </div>
    </template>
    <oferta-popup ref="oferta" @close="$refs.oferta.close()">
      <p>
        Lorem ipsum dolor sit amet consectetur adipisicing elit. Exercitationem
        dolore maiores consequatur beatae placeat sed alias aliquid fugiat
        expedita quam, autem, eligendi saepe ad nostrum repellendus neque labore
        a obcaecati.
      </p>
    </oferta-popup>
    <div class="no-contract" v-if="noContract">
      <h3>Трекинговый заказ доступен после заключения договора</h3>
      <p>Для доступа к трекинговым заказам необходимо заключить договор с ООО «{{ contacts[platform].title }}»</p>
      <ob-button label="Заключить договор" @click="$router.push({name: 'contracts__new__tracking', params: {id: 'tracking'}})" />
      <router-link to="/order__drafts">Вернуться в браузер заказов</router-link>
    </div>

    <ob-modal
        ref="cancelOrderModal"
        title="Отмена заказа"
        size="small"
        :is-show-controls="true"
        ok-text="Отменить"
        cancel-text="Нет, не отменять"
        @submit="cancelOrder2"
    >
      <p>
        Данный заказ будет отменен, все внесенные данные будут удалены. Вы действительно хотите отменить заказ?
      </p>
    </ob-modal>
  </div>
</template>

<script>
import api from '@/api';
import {uuid} from "vue-uuid";
import moment from 'moment'
import { contacts } from "@/resources/contacts";

import Preloader from '@/services/Preloader/Preloader'
import orderLogistInfo from '../../components/Order/orderLogistInfo';
import obTooltip from "common-components/src/obComponents/obTooltip";
import ObAddressInput from "common-components/src/obComponents/obAddressInput";
import obStepper from "common-components/src/obComponents/obStepper";
// import orderDatePicker from "../../components/Order/orderDatePicker";
import orderDatePicker from "common-components/src/obComponents/obDatePickerConstructor";
// import serviceCard from '../../components/OrderService';
import obCheckbox from 'common-components/src/obComponents/obCheckbox';
import obInput from 'common-components/src/obComponents/obInput';
import obTextArea from 'common-components/src/obComponents/obTextarea';
// import expandTransition from 'common-components/src/obComponents/obExpandTransition';
import obButton from 'common-components/src/obComponents/obButton';
import ObModal from "common-components/src/obComponents/obModal";
import ObForm from 'common-components/src/obComponents/obForm'
import FormValidationMixin from 'common-components/src/obComponents/obForm/FormValidationMixin'
import OfertaPopup from "@/components/Oferta";
import { required } from "vuelidate/lib/validators";

export default {
  name: "orderTracking",

  components: {
    Preloader,
    orderLogistInfo,
    obTooltip,
    ObAddressInput,
    obStepper,
    orderDatePicker,
    // serviceCard,
    obCheckbox,
    obInput,
    obTextArea,
    // expandTransition,
    obButton,
    ObModal,
    ObForm,
    OfertaPopup,
  },

  mixins: [
    FormValidationMixin,
  ],

  computed: {
    formModel() {
      return {
        carNumber: {
          value: '',
          validator: {
            checkLength: {
              method: this.validateCarNumber,
              error: 'Номер тягача введён не полностью'
            },
            checkSymbols: {
              method: this.validateCarNumberSymbols,
              error: 'Введён некорректный символ'
            },
            checkrequired: {
              method: this.checkCarNumberDirty,
              error: 'Поле обязательно для заполнения'
            },
          }
        },
        trailerNumber: {
          value: '',
          validator: {
            checkLength: {
              method: this.validateTrailerNumberLength,
              error: 'Номер прицепа введён не полностью'
            },
            checkSymbols: {
              method: this.validateTrailerNumberSymbols,
              error: 'Введён некорректный символ'
            }
          }
        },
        driverPhone : {
          value: '',
          validator: {
            required,
            checkLength: {
              method: this.validateDriverPhone,
              error: 'Некорректный номер телефона'
            }
          }
        },
        driverName : {
          value: '',
          validator: {
            required,
            checkLength: {
              method: this.validateDriverName,
            }
          }
        }
      }
    },
    blockTimeDate() {
      const h = new Date(this.dateFrom).getHours() + 1;
      return (new Date(this.dateFrom)).setHours(h, 0)
    },

    isRouteValid() {
      return !!(this.logchain && this.logchain.routeDuration > 0 && this.isRadiusesValid);
    },

    isRadiusesValid() {
      const wrongLoadingRadius = this.loadingLocations.find(item => item.isRadiusWrong);
      const wrongUnloadingRadius = this.unloadingLocations.find(item => item.isRadiusWrong);
      const correctLoadingRadius =  this.loadingLocations.some(location => !location.parkingRadius || !location.targetRadius || location.parkingRadius < 10 || location.parkingRadius > 10000 || location.targetRadius < 10 || location.targetRadius > 10000);
      const correctUnloadingRadius =  this.unloadingLocations.some(location => !location.parkingRadius || !location.targetRadius || location.parkingRadius < 10 || location.parkingRadius > 10000 || location.targetRadius < 10 || location.targetRadius > 10000);
      return wrongLoadingRadius || wrongUnloadingRadius || correctLoadingRadius || correctUnloadingRadius ? false : true
    },

    isTargetsValid() {
      return this.isValidForm;
    },

    isServicesValid() {
      return this.orderedServices.length;
    },

    isOrderValid() {
      return this.isRouteValid && this.isTargetsValid && this.isServicesValid && this.oferta && this.isLocationsValid && this.isTrackingIntervalValid && this.formData.carNumber.length;
    },

    carNumberMask() {
      const numberMasksMap = {
        'TRUCK': 'A 000 AA 00(0)',
        'TRAILER': 'AA 0000 00(0)'
      }
      return this.formatCarNumber ? numberMasksMap['TRUCK'] : '';
    },

    trailerNumberMask() {
      const numberMasksMap = {
        'TRUCK': 'A 000 AA 00(0)',
        'TRAILER': 'AA 0000 00(0)'
      }
      return this.formatCarNumber ? numberMasksMap['TRAILER'] : '';
    },

    phomeNumberMask() {
      return this.formatPhoneNumber ? '+7 (999) 999-99-99' : '';
    },

    platform() {
      return window.OBOZ_CONFIG.OBOZ_API_HOST.includes("oboz")
        ? "oboz"
        : "gruzi";
    },

    contacts() {
      return contacts;
    }
  },

  watch: {
    dateFrom(newVal) {
      this.dateTo = (new Date()).setDate((new Date(newVal)).getDate() + 1)
    },
    formatPhoneNumber(newVal) {
      if (!newVal) {
        this.$refs.driverPhone.localValue = this.formData.driverPhone;
      }
    }
  },

  data() {
    return {
      isCarNumberDirty: false,
      isCarNumberSymbolsValid: true,
      isTrailerNumberSymbolsValid: true,
      regnumMaskTokens: {
        '0': { pattern: /\d/ },
        'A': {
          pattern: /[ABEKMHOPCTXYАВЕКМНОРСТУХ]/i,
          transform: v => v.toLocaleUpperCase()
        }
      },
      formData: {
        carNumber: '',
        trailerNumber:'',
        driverPhone: '',
        driverName: '',
      },
      defaultParkingRadius: '',
      defaultTargetRadius: '',
      isValidForm: false,
      isCostBusy: false,
      isLoading: true,
      formatCarNumber: true,
      formatPhoneNumber: true,
      noContract: false,
      client: {
        uuid: '',
        name: '',
        role: ''
      },
      contractor: {
        uuid: '',
        name: '',
        role: ''
      },
      logist: {
        uuid: '',
        firstName: '',
        lastName: '',
        patronymic: '',
        email: ''
      },
      mapAddressFrom: {},
      mapAddressTo: {},
      loadingLocations: [],
      unloadingLocations: [],
      fromPointsShow: false,
      toPointsShow: false,
      logchain: null,
      activeFromPoints: "",
      activeToPoints: "",
      isCostExpanded: false,
      oferta: true,
      type: "",
      orderNumber: '',
      externalNumber: '',
      comment: '',
      trackingStartDt: {
        value: '',
        errorTooltip: '',
      },
      trackingEndDt: {
        value: '',
        errorTooltip: '',
      },
      orderedServices: [
        {
          serviceUuid: '9216f7ce-72b9-4986-9c47-4c9febb76088',
          title: 'Трекинг базовый',
          price: 15000,
        }
      ],
      cost: {
        totalCost: 500000,
        totalVat: 20,
        services: [
          {
            serviceUuid: '9216f7ce-72b9-4986-9c47-4c9febb76088',
            title: 'Трекинг базовый',
            price: 500000,
          }
        ]
      },
      services: [
        {
          serviceUuid: '9216f7ce-72b9-4986-9c47-4c9febb76088',
          title: 'Трекинг базовый',
          price: 500000,
          icon: 'tracking',
          description: 'Фактические данные об отметках на точках маршрута и базовые данные о местоположении груза',
          unit: 'рейс',
          disabled: true
        },
        {
          serviceUuid: '9f565f1b-eca0-495b-8ecc-e74edbbbb8e3',
          title: 'Прогнозирование прибытия на маршруте',
          price: 600000,
          icon: 'tracking',
          description: 'Расчет планового прибытия ТС на точки маршрута, уведомления об опозданиях и прогноз времени прибытия в конечные точки маршрута',
          unit: 'рейс',
          disabled: false
        },
        {
          serviceUuid: '24b547e9-9c65-424d-9dcd-b5c3f310dd93',
          title: 'Мониторинг отклонения от маршрута',
          price: 300000,
          icon: 'tracking',
          description: 'Оповещения для контроля движения ТС в процессе выполнения рейса',
          unit: 'рейс',
          disabled: false
        },
        {
          serviceUuid: '69827ae5-5c9a-479e-b5b7-02b670c1059a',
          title: 'Отслеживание температуры транспортировки on-line',
          price: 600000,
          icon: 'tracking',
          description: 'Анализ данных на основе телеметрии',
          unit: 'рейс',
          disabled: false
        },
        {
          serviceUuid: 'e076f16d-cf23-4687-b5bd-efef7336af95',
          title: 'Уведомление участников',
          price: 600000,
          icon: 'tracking',
          description: 'Уведомление заинтересованных сторон в процессе выполнения рейса о происходящих событиях',
          unit: 'рейс',
          disabled: true
        }
      ],
      isLocationsValid: true,
      isTrackingIntervalValid: true,
    };
  },

  async created() {

    try {
      const res = await api.orders.initTrackingOrder();
        if (res.orderNumber) {
          this.orderedServices = res.services;
          await this.initNewOrder(res);
        } else {
          this.noContract = true;
        }
    } catch (e) {
      this.noContract = true;
    } finally {
      this.initDates();
      this.isLoading = false;
    }
  },

  methods: {
    validateCarNumberSymbols() {
      return this.isCarNumberSymbolsValid;
    },
    validateTrailerNumberSymbols() {
      return this.isTrailerNumberSymbolsValid
    },
    onPhonePaste(e) {
      if (this.formatPhoneNumber) return;
      e.stopPropagation();
      e.preventDefault();
      const re = /(?<=\+.*)[^0-9-]/g;
      const text = (e.originalEvent || e).clipboardData.getData('text/plain');const clearString = text.toString().replace(re, '');
      this.formData.driverPhone = clearString;
    },
    onPhoneEnter(e) {
      if (this.formatPhoneNumber) return
      const isPlus = (e.keyCode === 187 && e.shiftKey === true);
      if (
        [46, 8, 9, 27, 13].indexOf(e.keyCode) !== -1 ||
        // Allow: Ctrl+A
        (e.keyCode === 65 && (e.ctrlKey === true || e.metaKey === true)) ||
        // Allow: Ctrl+C
        (e.keyCode === 67 && (e.ctrlKey === true || e.metaKey === true)) ||
        // Allow: Ctrl+X
        (e.keyCode === 88 && (e.ctrlKey === true || e.metaKey === true)) ||
        // Allow: Ctrl+V
        (e.keyCode === 86 && (e.ctrlKey === true || e.metaKey === true)) ||
        // Allow: home, end, left, right
        (e.keyCode >= 35 && e.keyCode <= 39) ||
        (isPlus && e.target.selectionStart === 0)
      ) {
        return;
      }
      if(this.formData.driverPhone.length >= 13) {
        e.preventDefault();
      }
      // Ensure that it is a number and stop the keypress
      if (
        (e.shiftKey || e.keyCode < 48 || e.keyCode > 57) &&
        (e.keyCode < 96 || e.keyCode > 105)
      ) {
        e.preventDefault();
      }
    },

    capitalizeNumber(field) {
      this.formData[field] = this.formData[field].toUpperCase();
    },
    translit(string) {
      const text = string
      .replace(/\u0410/g, 'A')
      .replace(/\u0412/g, 'B')
      .replace(/\u0415/g, 'E')
      .replace(/\u041A/g, 'K')
      .replace(/\u041C/g, 'M')
      .replace(/\u041D/g, 'H')
      .replace(/\u041E/g, 'O')
      .replace(/\u0420/g, 'P')
      .replace(/\u0421/g, 'C')
      .replace(/\u0422/g, 'T')
      .replace(/\u0423/g, 'Y')
      .replace(/\u0425/g, 'X');

      return text;
    },
    dirtCarNumber() {
      this.isCarNumberDirty = true;
    },

    checkCarNumberDirty() {
      if (this.isCarNumberDirty && !this.formData.carNumber.length) {
        return false;
      }
      return true;
    },

    validateNumber(e, type) {
      const types = {
        carNumber: 'isCarNumberSymbolsValid',
        trailerNumber: 'isTrailerNumberSymbolsValid'
      }
      const target = types[type]
      if (this.formatCarNumber) {
        this[target] = true;
        return;
      }
      const reg = new RegExp(/[A-Z\d]/g);
      const correctNumber = e.key.toUpperCase().match(reg);
      const isShortcut = (e.keyCode === 65 && e.ctrlKey === true) ||
        (e.keyCode === 67 && e.ctrlKey === true) ||
        (e.keyCode === 88 && e.ctrlKey === true) ||
        (e.keyCode >= 35 && e.keyCode <= 39);
      if (!correctNumber && !isShortcut) {
        this[target] = false;
        e.preventDefault();
      } else if (correctNumber || isShortcut) {
        this[target] = true;
        return;
      }
    },
    checkRadius(location) {
      location.isRadiusWrong = +location.parkingRadius < +location.targetRadius;
    },

    initDates() {
      const loadingDt = moment().add(1,'day').hours(12).minutes(0).seconds(0).milliseconds(0);
      this.addLoadingPoint(loadingDt);
      this.addUnloadingPoint(null);
    },

    async initNewOrder(order) {
      this.orderNumber = order.orderNumber;
      this.client.uuid = order.clientUuid;
      this.client.title = order.clientName;
      this.client.role = order.clientRole;
      this.contractor.uuid = order.executorUuid;
      this.contractor.title = order.executorName;
      this.contractor.role = order.executorRole;
      this.logist.uuid = order.logistUuid;
      this.logist.lastname = order.logistLastName;
      this.logist.firstname = order.logistName;
      this.logist.patronymic = order.logistPatronymic;
      this.logist.email = order.logistEmail;
      this.defaultParkingRadius =  order.defaultParkingRadius || 3000,
      this.defaultTargetRadius = order.defaultTargetRadius || 1500,

      this.services.map(item => {
        item.disabled = !order.services.some(service => service.serviceUuid === item.serviceUuid)
        if (item.disabled) {
          item.price = null;
        }

        if (!item.disabled) {
          const target = order.services.find(service => service.serviceUuid === item.serviceUuid);
          item.price = target.price;
        }

        if (item.serviceUuid === "9216f7ce-72b9-4986-9c47-4c9febb76088") {
          item.disabled = true;
        }
      });

      await this.getCost();
    },

    async getCost() {
      this.isCostBusy = true;
      const payload = this.orderedServices.reduce((acc, item) => {
        acc.push({serviceUuid: item.serviceUuid});
        return acc;
      }, [])
      try {
        const res = await api.orders.getServiceCost({services: payload});
        this.cost = { ...res }
      } catch (e) {
        console.error(e)
      } finally {
        this.isCostBusy = false;
      }
    },

    async saveOrder() {
      let notificationId = new Date().getTime() + "save";
      const orderUuid = uuid.v4();
      const locations = [];
      let ordinal = 1;
      this.loadingLocations.forEach(loc => {
        if (loc) {
          locations.push({
            locationUuid: loc.locationUuid,
            locationTitle: loc.label,
            locationCoord: loc.coordinates,
            loadingUnloadingDt: new Date(loc.loadingUnloadingDt).toISOString(),
            parkingRadius: loc.parkingRadius || this.defaultParkingRadius,
            targetRadius: loc.targetRadius || this.defaultTargetRadius,
            ordinal,
            operationType: 'LOADING',
          })
          ordinal++;
        }
      })
      this.unloadingLocations.forEach(loc => {
        if (loc) {
          locations.push({
            locationUuid: loc.locationUuid,
            locationTitle: loc.label,
            locationCoord: loc.coordinates,
            loadingUnloadingDt: new Date(loc.loadingUnloadingDt).toISOString(),
            parkingRadius: loc.parkingRadius || this.defaultParkingRadius,
            targetRadius: loc.targetRadius || this.defaultTargetRadius,
            ordinal,
            operationType: 'UNLOADING',
          })
          ordinal++;
        }
      })

      const order = {
        mainData: {
          logistUuid: this.logist.uuid,
          number: this.orderNumber,
          externalNumber: this.externalNumber,
          tractorNumber: this.translit(this.formData.carNumber.replace(/\s/g, '')),
          wagonNumber: this.translit(this.formData.trailerNumber.replace(/\s/g, '')),
          driverPhone: this.formData.driverPhone.replace(/[\s-()+]/g,""),
          driverFio: this.formData.driverName,
          locations,
          routeDurationInHr: this.logchain.routeDuration,
          routeLengthInKm: this.logchain.routeLength,
          comment: this.comment,
          trackingStartDt: this.trackingStartDt.value,
          trackingEndDt: this.trackingEndDt.value,
        },
        orderedServices: this.orderedServices.map(service => {
          return {serviceUuid: service.serviceUuid}
        })
      }

      try {
        this.$notification({
          type: "system_notification_in_load",
          message: "Сохранение",
          id: notificationId
        });
        await api.orders.saveTrackingOrder(orderUuid, order)
        this.$router.push('/order__performerer');
      } catch (e) {
        this.$notification({
          type: "system_notification_error",
          message: "Не удалось сохранить"
        });
        console.error(e);
      } finally {
        this.$notification({ event: "close", id: notificationId });
      }
    },

    isServiceActive(uuid) {
      return this.orderedServices.some(service => service.serviceUuid === uuid);
    },

    async setAddress(location, address) {
      if (address) {
        location = Object.assign(location, address);
        if (!address.icon) {
          location.icon = 'pin';
        }
        if (location.coordinates && location.coordinates.lat && location.coordinates.lon) {
          const route = [];
          this.loadingLocations.forEach(loc => {
            if (loc && loc.coordinates && loc.coordinates.lat && loc.coordinates.lon) {
              route.push([
                loc.coordinates.lat,
                loc.coordinates.lon,
              ])
            }
          })
          this.unloadingLocations.forEach(loc => {
            if (loc && loc.coordinates && loc.coordinates.lat && loc.coordinates.lon) {
              route.push([
                loc.coordinates.lat,
                loc.coordinates.lon,
              ])
            }
          })

          if (route.length > 0) {
            const res = await api.geocoder.getRoute(route);
            this.logchain = {
              routeLength: res.data.properties.path_lenght,
              routeDuration: res.data.properties.estimated_time,
            }
          } else {
            this.logchain = {
              routeLength: '',
              routeDuration: '',
            }
          }
        }
      } else {
        const emptyLoc = this.getOneLocation(location.loadingUnloadingDt);
        location = Object.assign(location, emptyLoc);
      }
      this.processEstimatedTime();
    },

    changePoints() {
      console.log("change points");
    },

    onServiceChanged($event) {
      if ($event.status) {
        this.orderedServices.push({
            serviceUuid: $event.event.serviceUuid,
            title: $event.event.title,
            price: $event.event.price
          });
      } else {
        this.orderedServices = this.orderedServices.filter(item => item.serviceUuid !== $event.event.serviceUuid)
      }

      this.getCost();
    },

    openOferta() {
      this.$refs.oferta.open();
    },

    changeOrderStatus() {
      this.saveOrder();
    },

    cancelOrder() {
      this.$refs.cancelOrderModal.open();
    },

    cancelOrder2() {
      this.$router.push('/order__performerer');
    },

    getLength(value) {
      return Math.ceil(value / 1000);
    },

    getDuration(duration) {
      const fm = [
        Math.floor((duration * 60) / (3600 * 24)),
        Math.ceil(((duration * 60) % (3600 * 24)) / 3600)
      ];
      return fm
        .map((v, i) => {
          if (v) {
            if (i === 0) {
              v = this.plural(v, "день | дня | дней");
            } else if (i === 1) {
              v = this.plural(v, "час | часа | часов");
            } else if (i === 2) {
              v = this.plural(v, "минута| минуты | минут");
            } else if (i === 3) {
              v = this.plural(v, "секунда | секунды | секунд");
            }
            return v;
          }
        })
        .join(" ");
    },

    plural(value, unit) {
      return value + this.declOfNum(value, unit);
    },

    declOfNum(n, string) {
      let titles = string.split("|");
      return titles[
        n % 10 == 1 && n % 100 != 11
          ? 0
          : n % 10 >= 2 && n % 10 <= 4 && (n % 100 < 10 || n % 100 >= 20)
          ? 1
          : 2
      ];
    },

    getOneLocation(dt) {
      return {
        loadingUnloadingDt: dt || '',
        isDtChangedByUser: false,
        coordinates: {
          lat: 0,
          lon: 0,
        },
        locationTitle: '',
        locationUuid: null,
        parkingRadius: this.defaultParkingRadius,
        targetRadius: this.defaultTargetRadius,
        isRadiusWrong: false,
        valid: true,
        errorTooltip: '',
        estimated: {
          fromUuid: null,
          time: null,
        }
      }
    },

    calculateNextDt(dt) {
      return dt ? moment(dt).add(1,'day') : '';
    },

    findLastDt(list, beforePos = list.length) {
      let dt = null;
      list.forEach((loc, i) => {
        if (i <= beforePos) {
          if (loc && loc.loadingUnloadingDt) {
            dt = loc.loadingUnloadingDt;
          }
        }
      })
      return dt;
    },

    getNewLoadingDt(beforePos) {
      let dt = this.findLastDt(this.loadingLocations, beforePos);
      if (dt) {
        dt = this.calculateNextDt(dt);
      }
      return dt;
    },

    getNewUnloadingDt(beforePos) {
      let dt;
      if (this.unloadingLocations.length > 0) {
        dt = this.findLastDt(this.unloadingLocations, beforePos);
      } else {
        dt = this.findLastDt(this.loadingLocations, undefined);
      }
      if (dt) {
        dt = this.calculateNextDt(dt);
      }
      return dt;
    },

    recalculateDt(list, baseDT, pos = 0) {
      let dt = baseDT;
      list.forEach((loc, i) => {
        if (loc && i >= pos) {
          if (loc.isDtChangedByUser) {
            dt = loc.loadingUnloadingDt;
          } else {
            dt = this.calculateNextDt(dt);
            loc.loadingUnloadingDt = dt;
          }
        }
      })
    },

    addLoadingPoint(dt) {
      if (!dt) {
        dt = this.getNewLoadingDt();
      }
      this.loadingLocations.push(this.getOneLocation(dt));
      this.recalculateDt(this.unloadingLocations, dt);
    },

    addUnloadingPoint(dt) {
      if (!dt) {
        dt = this.getNewUnloadingDt();
      }
      this.unloadingLocations.push(this.getOneLocation(dt));
    },

    removeLoadingPoint(pos) {
      this.loadingLocations.splice(pos, 1);
      let dt = this.findLastDt(this.loadingLocations, pos - 1);
      this.recalculateDt(this.loadingLocations, dt, pos);
      let lastLoadingDT = this.findLastDt(this.loadingLocations, undefined);
      this.recalculateDt(this.unloadingLocations, lastLoadingDT, undefined);
      this.processEstimatedTime();
    },

    removeUnloadingPoint(pos) {
      this.unloadingLocations.splice(pos, 1);
      let dt = this.findLastDt(this.unloadingLocations, pos - 1);
      this.recalculateDt(this.unloadingLocations, dt, pos);
      this.processEstimatedTime();
    },

    onDtChangeByUser(location) {
      location.isDtChangedByUser = true;
      this.validate();
    },

    async processEstimatedTime() {
      this.isLocationsValid = false;
      let prevLocation = null;
      let forLoad = [];

      function checkEstimated(loc) {
        if (!loc.estimated.fromUuid || loc.estimated.fromUuid !== prevLocation.locationUuid) {
          loc.estimated.fromUuid = prevLocation.locationUuid;
          forLoad.push({
            from: prevLocation,
            to: loc,
          })
        }
      }

      this.loadingLocations.forEach((loc, pos) => {
        if (loc.locationUuid) {
          if (pos > 0) {
            checkEstimated(loc);
          }
          prevLocation = loc;
        }
      })
      this.unloadingLocations.forEach(loc => {
        if (loc.locationUuid) {
          checkEstimated(loc);
          prevLocation = loc;
        }
      })

      if (forLoad.length > 0) {
        let promises = [];
        forLoad.forEach(item => {
          let route = [
            [
              item.from.coordinates.lat,
              item.from.coordinates.lon,
            ],
            [
              item.to.coordinates.lat,
              item.to.coordinates.lon,
            ],
          ]
          promises.push(api.geocoder.getRoute(route));
        })

        const resArray = await Promise.all(promises);
        if (resArray) {
          resArray.forEach((res, pos) => {
            forLoad[pos].to.estimated.time = res.data.properties.estimated_time;
          })
        }
        this.validate();
      } else {
        this.validate();
      }
    },

    validate() {
      let isLocationsValid = true;
      let prevDt;
      const now = new Date().valueOf();
      this.loadingLocations.forEach(loc => {
        if (loc.loadingUnloadingDt) {
          let dt = new Date(loc.loadingUnloadingDt).valueOf();
          const estimatedTime = loc.estimated.time ? loc.estimated.time * 60000 : 0;
          if (dt <= now) {
            loc.valid = false;
            loc.errorTooltip = 'Дата и время должны быть позднее текущего момента';
            isLocationsValid = false;
          } else if (prevDt && dt <= prevDt + estimatedTime) {
            loc.valid = false;
            loc.errorTooltip = `Дата и время должны быть позднее ${this.formatDate(prevDt + estimatedTime)}`;
            isLocationsValid = false;
          } else {
            loc.valid = true;
            loc.errorTooltip = '';
          }
          prevDt = dt;
        } else if (loc.locationUuid) {
          loc.valid = false;
          loc.errorTooltip = 'Укажите дату и время';
              isLocationsValid = false;
        }
      })
      this.unloadingLocations.forEach(loc => {
        if (loc.loadingUnloadingDt) {
          let dt = new Date(loc.loadingUnloadingDt).valueOf();
          const estimatedTime = loc.estimated.time ? loc.estimated.time * 60000 : 0;
          if (dt <= now) {
            loc.valid = false;
            loc.errorTooltip = 'Дата и время должны быть позднее текущего момента';
            isLocationsValid = false;
          } else if (prevDt && dt <= prevDt + estimatedTime) {
            loc.valid = false;
            loc.errorTooltip = `Дата и время должны быть позднее ${this.formatDate(prevDt + estimatedTime)}`;
            isLocationsValid = false;
          } else {
            loc.valid = true;
            loc.errorTooltip = '';
          }
          prevDt = dt;
        } else if (loc.locationUuid) {
          loc.valid = false;
          loc.errorTooltip = 'Укажите дату и время';
          isLocationsValid = false;
        }
      })
      this.isLocationsValid = isLocationsValid;

      this.validateTrackingDt();
    },

    formatDate(date) {
      return this.$options.filters.date(date, 'DD.MM.YYYY HH:mm');
    },

    validateTrackingDt() {
      let isValid = true;
      const firstPointDtM = moment(this.loadingLocations[0].loadingUnloadingDt);
      const lastPointDtM = moment(this.unloadingLocations[this.unloadingLocations.length - 1].loadingUnloadingDt);

      if (this.trackingStartDt.value !== '' && firstPointDtM.isValid()) {
        const start = moment(this.trackingStartDt.value).valueOf();
        switch (true) {
          case start < moment().valueOf(): {
            this.trackingStartDt.errorTooltip = 'Начало трекинга должно быть позднее текущего момента';
            isValid = false;
            break;
          }
          case start > firstPointDtM.valueOf(): {
            this.trackingStartDt.errorTooltip = `Начало трекинга должно быть ранее ${this.formatDate(firstPointDtM.valueOf())}`;
            isValid = false;
            break;
          }
          default: {
            this.trackingStartDt.errorTooltip = '';
          }
        }
      } else {
        this.trackingStartDt.errorTooltip = '';
      }

      if (this.trackingEndDt.value !== '' && lastPointDtM.isValid()) {
        const end = moment(this.trackingEndDt.value).valueOf();
        const lastPointPlusDelta = moment(lastPointDtM).add(24, 'hour').valueOf();
        switch (true) {
          case end < lastPointDtM.valueOf(): {
            this.trackingEndDt.errorTooltip = `Окончание трекинга должно быть позднее ${this.formatDate(lastPointDtM.valueOf())}`;
            isValid = false;
            break;
          }
          case end > lastPointPlusDelta: {
            this.trackingEndDt.errorTooltip = `Окончание трекинга должно быть ранее ${this.formatDate(lastPointPlusDelta)}`;
            isValid = false;
            break;
          }
          default: {
            this.trackingEndDt.errorTooltip = '';
          }
        }
      } else {
        this.trackingEndDt.errorTooltip = '';
      }

      this.isTrackingIntervalValid = isValid;
    },

    validateCarNumber (value) {
      if (!this.formatCarNumber || !value) {
        return true
      }
      // -3 to remove non-required number in brackets
      return value.length >= this.carNumberMask.replace(/\s+/g, '').length - 3
    },

    validateTrailerNumberLength (value) {
      if (!this.formatCarNumber || !value) {
        return true
      }
      // -3 to remove non-required number in brackets
      return value.length >= this.trailerNumberMask.replace(/\s+/g, '').length - 3
    },

    validateDriverPhone(value) {
      const trimmedValue = value.replace(/[+\s-()]/g, '');
      if (!this.formatPhoneNumber) {
        return (!value || trimmedValue.length >= 9 && trimmedValue.length <= 13)
      } else {
        const isFirstZero = trimmedValue[1] == 0
        return (value && trimmedValue.length >= 10 && !isFirstZero)
      }
    },

    validateDriverName(value) {
      return value && value.length;
    },
  },
};
</script>

<style lang="scss" scoped>
@import "~common-components/src/static/css/variables";
@import "~common-components/src/static/css/mixins";

.ob-order {
  margin: 20px;
  background: $background-white;
  border-radius: 3px;
  position: relative;
  width: calc(100% - 40px);
}

.ob-order__header {
  display: flex;
  width: 100%;
  min-height: 80px;
  padding: 14px 20px 0 20px;
  position: relative;
  z-index: 1;
  box-shadow: 0 0 10px -4px rgba(0, 75, 200, 0.6);
  background-color: $background-white;
}

.order-info {
  @include font-mixin(24px, 28px, 700, $style-black);
  display: flex;
  align-items: center;

  .icon {
    margin-right: 9px;
    font-size: 12px;
    font-weight: 400;
    line-height: 20px;
    letter-spacing: 0.2px;
    color: $blue-700;
    text-transform: none;
    text-decoration: none;
  }

  span {
    @include font-mixin(10px, 20px, 400, $gray-slate, 0.4px, uppercase);
    align-self: flex-start;
  }
}

.order-details {
  margin-top: 6px;
  display: flex;
  align-items: center;
}

.ob-order__content {
  display: flex;
  width: 100%;
  position: relative;
}

.ob-order__content-left {
  width: calc(100% - 316px);
  overflow: hidden;
  padding-top: 15px;
}

.ob-order__content-right {
  position: relative;
  z-index: 2;
  margin-top: -80px;
  box-shadow: 0 0 10px -4px rgba(0, 75, 200, 0.6);
  background: $background-white;
  width: 316px;
  min-height: calc(100vh - 144px);
}

.ob-order__content-right-container {
  height: calc(100% - 70px);
  overflow-y: auto;
}

.order-step {
  padding: 4px 19px 10px;
}

.order-step__header {
  display: flex;
  align-items: center;
  justify-content: space-between;
  margin-bottom: 27px;

  div {
    display: flex;
    align-items: center;

    &:not(:last-child) {
      margin-right: 30px;
    }
  }

  .ob-inline-select {
    margin-left: 5px;
  }
}

.order-step-title {
    margin: 0 0 7px;
    font-weight: bold;
    font-size: 20px;
    line-height: 28px;
    letter-spacing: 0.4px;
    color: #191e32;
    display: flex;
    align-items: center;

    .icon {
      display: flex;
      margin-left: 6px;
      color: $color-grey-border;
    }

    &.active {
      .icon {
        color: $color-green-light;
      }
    }

    &--services {
      display: flex;
      align-items: center;

      span {
        margin-left: 10px;
        @include font-mixin(16px, 24px, 700, $gray-slate);
      }
    }
  }

.order-step__route-header {
  display: flex;
  align-items: center;
}

.order-route__row {
  width: 100%;
  padding: 10px 0;
}

.order-route__row + .order-route__row {
  margin-top: 10px;
  padding-left: 20px;

  &:hover {
    background-color: $color-white-lilac;
  }
}

.order-step__route-info {
  margin: 0 0 5px 30px;
  @include font-mixin(12px, 16px, 400, $color-blue-navy-blue);

  span {
    margin-right: 20px;
    color: $gray-slate;
  }
}

.order-route__location {
  flex: 0 0 80%;
  min-width: 250px;
  display: flex;

  @media screen and (max-width: 1450px) {
    flex: 0 0 70%;
  }
}

.order-route__location-input-path {
  font-size: 16px;
  line-height: 20px;
  letter-spacing: 0.4px;
  padding-bottom: 10px;
  display: flex;
  align-items: center;

  i:first-of-type {
    margin-right: 5px;
  }

  i:last-of-type {
    color: $color-grey-span;
    cursor: pointer;
  }
}

.order-route__row + .order-route__row {
  .order-route__location-input-path {
    i:last-of-type {
      margin-left: auto;
    }
  }
}

.order-route__row-content {
  display: flex;
}

.order-route__add {
  display: inline-flex;
  font-size: 14px;
  line-height: 16px;
  letter-spacing: 0.2px;
  color: $color-blue-navy-blue;
  padding: 10px 0 18px;
  cursor: pointer;

  .icon {
    margin-right: 5px;
  }
}

.order-route__location-input {
  flex-grow: 1;
}

.order-route__points {
  flex: 0 0 30%;
  max-width: 150px;
  margin-left: 10px;

  @media screen and (max-width: 1450px) {
    flex: 0 0 20%;
  }
}

.order-route__date {
  margin-left: 10px;
  z-index: 1;
  height: 52px;
  position: relative;
  flex-grow: 1;
}

.order-step__services, .order-step__targets, .order-step__params {
  margin-top: 15px;
}

.order-services {
  display: flex;
  flex-wrap: wrap;

  @media screen and (max-width: 1363px) {
    margin-top: -20px;
  }

  &::v-deep {
    .service {
      width: 178px;
      height: 163px;
      cursor: pointer;

      &:not(:last-child) {
        margin-right: 20px;
      }

      @media screen and (max-width: 1363px) {
        margin-top: 20px;
      }
    }
  }
}

.order-targets {
  display: flex;
  flex-direction: column;
}

.order-targets + .order-targets {
  margin-top: 15px;
}


.order-targets__header {
  margin-bottom: 10px;
  display: flex;
}

.order-targets__inputs {
  display: flex;
  justify-content: start;

  .ob-input-container + .ob-input-container {
    margin-left: 10px;
  }

  .order-targets__short-date + .order-targets__short-date {
    margin-left: 10px;
  }
}

.order-targets__short-input,
.order-targets__short-date{
  width: 235px;
}

.order-targets__long-input {
  width: 400px;
}

.order-step__params-item {
  margin-bottom: 20px;

  &:first-of-type {
    width: 310px;
  }
}

.ob-order__status {
  padding: 20px 30px 0;
  position: relative;

  &::v-deep {
    .preloader {
      position: absolute;
    }
  }
}

.ob-order__action {
  display: flex;
  justify-content: center;
}

.ob-order__action + .ob-order__action {
  margin-top: 5px;
}

.prime-cost {
  padding: 0 0 20px;
  border-bottom: 1px solid rgba(209, 210, 214, 0.5);

  h3 {
    margin-bottom: 17px;
  }

  p {
    display: flex;
    justify-content: space-between;
    font-size: 12px;
    color: $gray-slate;

    &:not(:last-child) {
      margin-bottom: 9px;
    }
  }
}

p.prime-cost__title {
  position: relative;
  color: $color-text-base;
  cursor: pointer;

  i {
    position: absolute;
    left: -18px;
  }

  &--expanded {
    i {
      transform: rotate(180deg);
    }
  }
}

.order-total {
  padding-bottom: 20px;
  border-bottom: 1px solid rgba(209, 210, 214, 0.5);

  p {
    display: flex;
    justify-content: space-between;
    @include font-mixin(12px, 14px, 400, $gray-slate);
  }

  p:first-child {
    margin-bottom: 10px;
    @include font-mixin(16px, 20px, 700, $topMenuTextHover);
  }
}

.oferta {
  padding-right: 27px;
  margin-bottom: 20px;
  display: flex;
  font-size: 12px;
  color: $gray-slate;

  a {
    color: $orderPage-oferta_link_color;
  }
}

.no-contract {
  position: absolute;
  width: 100%;
  height: 100%;
  top: 0;
  left: 0;
  background: #fff;
  z-index: 2;
  display: flex;
  flex-direction: column;
  justify-content: center;
  align-items: center;

  h3 {
    margin-bottom: 20px;
    @include font-mixin(24px, 36px, 700, $style-black);
  }

  p {
    margin-bottom: 20px;
    @include font-mixin(16px, 20px, 400, $color-text-base);
  }

  a {
    margin-top: 16px;
    @include font-mixin(14px, 18px, 400, $blue-700);
  }
}

.cost-preloader {
  height: 150px;

  &::v-deep {
    .loader {
      width: 80px;
      height: 80px;
      margin: -40px 0 0 -40px;
    }
  }
}

.order-route__location-info {
  margin-top: 10px;
  @include font-mixin(12px, 12px, 400, $gray-slate);

  span {
    color:$color-text-base;
  }
}

.order-route__row-radius {
  display: flex;
  align-items: center;
  margin-top: 10px;
  @include font-mixin(12px, 12px, 400, $color-text-base);
}

.order-route__row-radius-item {
  display: flex;
  align-items: center;

  &::v-deep {
    .ob-input-container {
      margin-left: 5px;

      .icon {
        font-size: 12px;
      }
    }

    .ob-input-wrap {
      height: 30px;
      width: 94px;
    }
  }
}

.order-route__row-radius-item {
  margin-right: 15px;
}

.wrong {
  &::v-deep {
    .ob-input-wrap.--theme-default,
    .ob-input-wrap.--theme-default.--focused {
      border-color: $color-error
    }
  }
}

.order-route__radius-error {
  display: flex;
  align-items: center;
  margin-left: 15px;
  color: $color-error;
}
</style>
